package com.nisum

import groovy.xml.XmlSlurper
import groovy.xml.slurpersupport.GPathResult
import groovy.xml.slurpersupport.Node
import groovy.xml.slurpersupport.NodeChild

class XMLParser {

    File file;

    public void loadFile(String fileLocation){
        file = new File(fileLocation);
    }

    public GPathResult createParser() {
        return new XmlSlurper().parse(file)
    }

    public GPathResult getNodeByPath(String[] path){
        GPathResult node = createParser()

        for (String nodeName : path) {
            node = node."${nodeName}"
        }

        return node;

    }

    public GPathResult findNodeByTagName(String tagName){
        GPathResult node = createParser()

        Iterator nodeBFS = node.breadthFirst()

        while (nodeBFS.hasNext()) {
            node = nodeBFS.next()

            if (node.name() == tagName) {
                return node
            }
        }

        return null
        //BFS to find node
    }

    public List<GPathResult> findAllNodesByTagName(String tagName){
        GPathResult node = createParser()
        List<GPathResult> matchingNodes = new ArrayList<>()

        Iterator nodeBFS = node.breadthFirst()

        while (nodeBFS.hasNext()) {
            node = nodeBFS.next()

            if (node.name() == tagName) {
                matchingNodes.add(node)
            }
        }

        return matchingNodes
        //BFS to find node
    }


}